import urllib.request
import xml.etree.ElementTree as etree

try:
    webdata = urllib.request.urlopen("https://www.kma.go.kr/XML/weather/sfc_web_map.xml")
    webxml = webdata.read()           # bytes code 형태로 자료를 읽음.  desc="\xea\xb5\xac ...
    webxml = webxml.decode('utf-8')   # bytes code 데이터를 문자열로 디코딩함
    #print(webxml)    # 날씨 정보가 일반 문자열 형식으로 출력된다. desc="구름조금"…

    with open('weather.xml', mode='w', encoding='UTF-8') as f: 	# 수집된 정보를 파일로 저장
        f.write(webxml)

    xmlfile = etree.parse("weather.xml")	# 문자 형식의 xml 문서를 ElementTree 타입으로 변환
    root = xmlfile.getroot()		# xml 문서의 root 엘리먼트(노드) 얻기
    print(root.tag) 			# {current}current : root 요소명 출력하기
    print(root[0].tag) 		# {current}weather : root 요소의 0번째 요소명 출력하기

    # findall 메소드로 데이터 출력하기
    children = root.findall(root[0].tag) 	# 현재 엘리먼트의 자식 태그 엘리먼트를 찾음

    for ch in children: 			# 날씨 예보 날짜 및 시간 출력을 위해 반복 처리
        y = ch.get("year")			# 현재 엘리먼트의 속성 값 읽기
        m = ch.get("month")
        d = ch.get("day")
        h = ch.get("hour")
        print(y + "년 " + m + "월 " + d + "일 " + h + "시 현재")

    for child in root: 			    # 지역, 온도, 날씨 상태 출력을 위해 반복 처리
        for ch in child:
            local_name = ch.text        # 엘리먼트값 얻기
            re_ta = ch.get("ta")		# 속성 값 읽기
            re_desc = ch.get("desc")
            print(local_name + " 온도:" + str(re_ta) + " " + re_desc)
except Exception as e:
    print('에러 : ', e)
