from bs4 import BeautifulSoup
# HTML 형식을 가진 문자열을 만든다.
test_str = """
<b>스크래핑 연습문서</b>
<div class="abc">뷰티플 수프 사용</div>
<div id="def">웹 문서 읽기</div>
<a href="https://www.kbs.co.kr">kbs</a>
<a href="https://www.sbs.co.kr">sbs</a>
"""

bsObj = BeautifulSoup(test_str, 'html.parser') 	# BeautifulSoup 객체 생성
print(bsObj)

btag = bsObj.b			# bs객체.하위태그 형태로 태그를 선택
print('선택 태그 : ', btag)
print('선택 태그의 텍스트 : ', btag.string)

print('find 메소드---')
print(bsObj.find('div')) 			# 첫 번째 div 태그가 선택됨
print(bsObj.find('div').string) 		# 첫 번째 div 태그를 찾아 텍스트 읽기
print(bsObj.find(attrs = 'abc').string) 	# 태그 중 속성 class가 'abc'인 텍스트 읽기
print(bsObj.find('div', {'id':'def'}).string) 	# div 태그 중 속성 id가 def를 찾아 텍스트 읽기

print('find_all 메소드---')
print(bsObj.find_all('a')) 		    # 모든 a 태그를 찾아 리스트로 반환
print(bsObj.find_all(['a', 'b'])) 	# 모든 a, b 태그를 찾아 리스트로 반환

atag = bsObj.find_all('a')
for i in atag: 		# 리스트로 반환된 a 태그를 반복문으로 하나씩 출력
    href = i.attrs['href'] 	# a 태그의 속성명이 'href'에 해당하는 속성값을 추출 후 기억
    text = i.string	        # a 태그의 텍스트를 추출 후 기억
    print('link:', href, ', text:', text)
