from bs4 import BeautifulSoup

test_str = """
<b>스크래핑 연습문서2</b>
<div id="first">뷰티플 수프 사용</div>
<div class="second">웹 문서 읽기</div>
<div>
  <a href="https://www.kbs.co.kr">kbs</a>
  <span><a href="https://www.sbs.co.kr">sbs</a></span>
</div>

<table>
<tr>
  <td id="hello">안녕</td>
  <td id="world">반가워</td>
</tr>
</table>
"""

bsObj = BeautifulSoup(test_str, 'html.parser')

print('select_one 메소드---') 	# select_one은 선택자에 맞는 첫 번째 태그 하나만을 찾는다.
print(bsObj.select_one('b').string) 	# 첫 번째 b 태그를 찾아 선택된 텍스트 출력
print(bsObj.select_one('div#first').string) 	# div 태그 중 id가 first인 태그를 찾아 텍스트 출력
print(bsObj.select_one('div.second').string) 	# div 태그 중 class가 second인 태그의 텍스트 출력
print(bsObj.select_one('div > a').string) 	# div 태그 바로 안에 포함된 자식태그 a를 찾아 출력
print(bsObj.select_one('div a').string)   # div 태그 안에 어딘가에 포함된 자손태그 a를 찾아 출력

print('select 메소드---')
# select는 선택자에 맞는 모든 태그를 찾아 리스트로 반환. 선택자는 select_one 방법과 같다.
print(bsObj.select('div a')) 		# div 태그 안에 포함된 자손태그 a를 모두 선택하게 됨
for i in bsObj.select('div a'): 	# div 태그의 자손태그 a를 하나씩 반복 처리
    print('text:', i.string)

print()
print(bsObj.select('table > tr > td'))  # table 태그 바로 안에, tr 태그 바로 안에, td 태그 모두 선택
print(bsObj.select('tr td#hello'))      # tr 태그에 포함된 td 태그 중에서 속성 id가 hello인 것을 모두 선택
