import urllib.request
from bs4 import BeautifulSoup

url = "https://news.daum.net/society#1"	    # 주소는 해당 페이지의 사정상 변경될 수 있다.
daum = urllib.request.urlopen(url).read()
soup = BeautifulSoup(daum, 'html.parser')

# select 메소드 사용하기
print(soup.select_one('div#kakaoIndex > a').string) 	# a 태그 한 개 출력  => 본문 바로가기
datas = soup.select('div#kakaoIndex > a') 	# id가 kakaoIndex인 div의 자식태그 중 여러 개의 a 태그를 선택한다.

for i in datas:
    href = i.attrs['href'] 			# 현재 태그에서 속성이 href인 값을 얻는다.
    text = i.string                 # 현재 태그에서 text를 얻는다.
    print('href:%s, text:%s'%(href, text)) 	# 서식 %s에 순서대로 text를 매칭

print()
# find_all 메소드 사용하기
datas = soup.find_all('a') 			# 본문에 있는 모든 a 태그를 찾는다.
#print(datas)                       # 스크래핑된 문서 중 모든 a 태그의 결과를 출력한다.

for i in datas[:5]: 			    # 모든 a 태그 중에서 5개만 작업에 참여한다
    href = i.attrs['href']
    text = i.string
    print('href:%s, text:%s'%(href, text))
