import urllib.request
from bs4 import BeautifulSoup
import datetime
import time

def scrapWorking():
    # 네이버 금융
    url = "https://finance.naver.com/sise/sise_index.naver?code=KOSPI"
    data = urllib.request.urlopen(url)
    bsObj = BeautifulSoup(data, 'html.parser')
    price = bsObj.select_one("div > em#now_value").string  #div 태그의 자식인 em 태그의 id가 now_value의 text를 읽는다.
    print('코스피 주가 : ', price)

    nalja = datetime.datetime.now()  # 현재 날짜와 시간을 얻는다.
    # print(nalja)  # 20**-07-02 15:58:57.876995 처럼 5초 마다 년월일 시분초밀리초를 출력

    fname = nalja.strftime('%Y-%m-%d-%H-%M-%S') + '.txt'
    # print(fname)  # 날짜와 시간을 이용해 20**-07-02-15-58-57.txt처럼 파일명을 만든다.

    with open(fname, 'w') as f:
        f.write(price)  # 10초마다 발생한 일시로 만든 txt 파일이 저장된다.

while True:
    scrapWorking()
    time.sleep(10)  # 10초에 한 번씩 반복 처리를 위해 5초 동안 일시 정지한다.
