import pygame
import sys

pygame.init()  # pygame 관련 모듈을 초기화한다.

windowSurface = pygame.display.set_mode((400, 300)) # 너비와 높이가 지정된 윈도우 객체(게임 스크린)를 생성한다.
pygame.display.set_caption('안녕 파이게임')   # 게임 스크린의 제목 

windowSurface.fill(color=(255, 255, 255))  # 게임 스크린의 기본 설정인 검은 바탕색을 흰색으로 변경

# 선 그리기: 지정된 색과 두께로 시작점(x좌표, y좌표)과 끝점을 잇는 선을 그린다.
pygame.draw.line(surface=windowSurface, color=(255, 0, 0), 
start_pos=(50, 30), end_pos=(100, 30), width=1)
pygame.draw.line(surface=windowSurface, color=(0, 0, 255), 
start_pos=(50, 50), end_pos=(200, 50), width=3)

# 원 그리기: 좌표 (100, 150)을 중심으로 하는 반지름 30인 원을 그린다
pygame.draw.circle(surface=windowSurface, color=(255, 0, 0), center=(100, 150), radius=30)

# 삼각형 그리기: 세 개의 꼭짓점을 이어 삼각형을 그린다.
pygame.draw.polygon(surface=windowSurface,
                    color=(0, 255, 0), points=((250, 100), (200, 150), (300, 150)))

pygame.display.update()  # 설정한 도형을 출력하기 위해 윈도우 화면을 갱신한다.

while True:              # while 조건이 참인 동안 게임 루프 처리됨
    for event in pygame.event.get():   # 게임 도중 발생하는 이벤트를 받는다.
        if event.type == pygame.QUIT:  # 이벤트 중 윈도우의 닫기 버튼을 누른 경우
            pygame.quit()  # 게임을 종료한다
            sys.exit()     # 응용 프로그램을 종료한다.
