import pygame
import sys

pygame.init()  # pygame 초기화
windowSurface = pygame.display.set_mode((400, 300))
pygame.display.set_caption('파이게임 에니메이션')

carImge = pygame.image.load('car.png')  # 자동차 이미지 읽기  (source 폴더에 제공됨)
carx = 10     # 이미지 표시용 x좌표
cary = 10     # 이미지 표시용 y좌표
direction = 'right'  # 이미지 이동을 위한 변수로 오른쪽 방향부터 이동되도록 설정
FPS = 30      # 초당 프레임 값 설정
fpsTimes = pygame.time.Clock()  # 게임 루프를 작성하기 전에 게임 루프의 주기 및 속도를 결정할 Clock 객체를 생성한다.

pygame.mixer.music.load('backsound.mp3')  # 배경 음악 파일 읽기 (source 폴더에 제공됨)
pygame.mixer.music.play()    # 배경 음악 재생 기능을 제공

while True:   # 게임 루프 처리
    windowSurface.fill(color=(255, 255, 255))  # 게임 스크린 배경은 흰색으로 설정

    if direction == 'right':
        carx += 5  # 이미지를 오른쪽으로 이동하기 위해 x좌표값을 5씩 증가시킴
        if carx == 300:direction = 'down'  # x값이 300이면 이미지 이동을 down하기 위함
    elif direction == 'down':
        cary += 5  # 이미지를 아래쪽으로 이동하기 위해 y좌표값을 5씩 증가시킴
        if cary == 250:direction = 'left'    # y값이 250이면 이미지 이동을 left하기 위함
    elif direction == 'left':
        carx -= 5   # 이미지를 왼쪽으로 이동하기 위해 x좌표값을 5씩 감소시킴
        if carx == 10:direction = 'up'      # x값이 10이면 이미지 이동을 up하기 위함
    elif direction == 'up':
        cary -= 5   # 이미지를 위쪽으로 이동하기 위해 y좌표값을 5씩 감소시킴
        if cary == 10:direction = 'right'   # y값이 10이면 이미지 이동을 right하기 위함

    windowSurface.blit(carImge, (carx, cary))  # blit 함수를 이용해 이미지를 그린다.

    pygame.display.update()
    fpsTimes.tick(FPS)  # Clock 객체에 초당 프레임 수를 지정해 준다.

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
            sys.exit()
