class Person:
    say = '난 사람~'		# 클래스 멤버변수
    nai = 20

    def __init__(self, nai):	# 생성자 매개변수로 nai를 받아 각 객체에 고유한 nai를 갖는다.
        print('Person 생성자')
        self.nai = nai

    def printInfo(self):	# self에 전달되는 객체 주소에 따라 say와 nai 값은 결정된다.
        print('say:{}, nai:{}'.format(self.say, self.nai))

person = Person('22')	# Person 객체 생성
person.printInfo()		# Person 클래스의 메소드를 호출

print('Employee 클래스 처리 ---')
class Employee(Person):	# Person의 자식 클래스가 된다.
    say = '일하는 동물'	# 부모와 같은 이름의 멤버변수에 부모와 다른 값이 기억된다.
    subject = '근로자'	# Employee만의 고유 멤버변수로 사용된다.

    def __init__(self):
        print('Employee 생성자')

    def eprintInfo(self):
        self.printInfo()	# 현재 클래스의 메소드를 참조하고, 없으면 부모 메소드를 참조
        super().printInfo()	# super()에 의해 바로 부모 메소드를 참조
        print(self.say)	    # 현재 클래스에서 say를 참조하고, 없으면 부모의 say를 참조
        print(super().say)	# super()에 의해 바로 부모의 say를 참조

    def printInfo(self):
        print('오버라이딩(override) : 부모와 같은 이름의 메소드를 자식에서도 선언')

empl = Employee()		# Employee 객체 생성
print(empl.say, empl.nai, empl.subject)
empl.eprintInfo()

print('Worker 클래스 처리 ---')
class Worker(Person):	# Person의 자식 클래스가 된다.
    def __init__(self, nai):
        print('Worker 생성자')
        super().__init__(nai)	# Worker의 부모클래스 생성자를 호출. nai를 인수로 전달한다.

    def wprintInfo(self):
        self.printInfo()	# 현재 클래스에서 메소드를 참조하고, 없으면 부모 메소드를 참조

work = Worker('31')	   # Worker 객체 생성
print(work.say, work.nai)
work.wprintInfo()

print('Programmer 클래스 처리 ---')
class Programmer(Worker):	# Worker의 자식 클래스가 된다.
    def __init__(self, nai):
        print('Programmer 생성자')
        # super().__init__(nai)	    # Bound call 방식으로 부모클래스 생성자를 호출
        Worker.__init__(self, nai)	# UnBound call 방식으로 부모클래스 생성자를 호출

    def pprintInfo(self):
        self.printInfo()	# printInfo()를 Programmer → Worker → Person 순으로 찾는다.
        super().printInfo()	# printInfo()를 Worker → Person 순으로 찾는다.

pr = Programmer(33)
print(pr.say, pr.nai)
pr.pprintInfo()
