from abc import *

class AbstractClass(metaclass=ABCMeta):  # 추상클래스
    @abstractmethod
    def abcMethod(self):      # 추상메소드
        pass

    def normalMethod(self):   # 일반메소드
        print('추상클래스 내의 일반 메소드')

class Child1(AbstractClass):    # 추상클래스를 상속한다.
    name = '난 Child1'

    def abcMethod(self):        # 메소드 선언을 강요한다.
        print('추상메소드를 오버라이드함')

c1 = Child1()         # Child1 객체 생성
print(c1.name)
c1.abcMethod()
c1.normalMethod()

class Child2(AbstractClass):   # 추상클래스를 상속한다.
    def abcMethod(self):       # 메소드 선언을 강요한다.
        print('추상메소드를 Child2에서 오버라이드함')

    def normalMethod(self):    # 일반 메소드 재정의는 선택적
        print('추상클래스의 일반 메소드를 재정의')

c2 = Child2          # Child2 객체 생성
c2.abcMethod(c2)
c2.normalMethod(c2)

#다형성
parent = c1
parent.abcMethod()
parent.normalMethod()    # 부모클래스의 메소드가 수행된다.

parent = c2
parent.abcMethod(parent)
parent.normalMethod(c2)  # 자식클래스의 메소드가 수행된다.
