from abc import *

class Employee(metaclass=ABCMeta):  # 추상클래스가 된다.
    def __init__(self, irum, nai):  # 추상 클래스도 생성자는 가질 수 있다.
        self.irum = irum
        self.nai = nai

    @abstractmethod        # 추상메소드로 자식클래스에게 오버라이드 강요
    def pay(self):
        pass

    @abstractmethod
    def data_print(self):  # 추상메소드
        pass

    def irumnai_print(self):  # 일반메소드이므로 자식클래스는 오버라이드 선택적
        print('이름 : ' + self.irum + ', 나이 : ' + str(self.nai), end=' ')

class Temporary(Employee):   # Employee의 자식클래스
    def __init__(self, irum, nai, ilsu, ildang):
        Employee.__init__(self, irum, nai)    # 부모 생성자를 호출하며 irum, nai 전달
        self.ilsu = ilsu       # ilsu와 ildang은 Temporary 클래스의 멤버
        self.ildang = ildang

    def pay(self):            # 메소드 오버라이드
        return self.ilsu * self.ildang

    def data_print(self):     # 메소드 오버라이드
        self.irumnai_print()         # 이름과 나이는 부모클래스의 메소드를 사용함
        print(', 월급 : ' + str(self.pay()))

class Regular(Employee):     # Employee의 자식클래스
    def __init__(self, irum, nai, salary):
        super().__init__(irum, nai)   # 부모 생성자를 호출하며 irum, nai 전달
        self.salary = salary   # salary는 Regular 클래스의 멤버

    def pay(self):           # 메소드 오버라이드
        return self.salary

    def data_print(self):    # 메소드 오버라이드
        self.irumnai_print()
        print(', 급여 : ' + str(self.pay()))

t = Temporary('홍길동', 25, 20, 150000)
r = Regular('한국인', 27, 3500000)
t.data_print()
r.data_print()
