import wx

fdatas = [
    ('홍길동', '서울', '2000'), 	 # ListCtrl에 출력할 데이터를 준비한다.
    ('김치국', '경기', '2005'),
]

class MyFrame(wx.Frame): 	     # wx.Frame 클래스를 상속받는다.
    def __init__(self, parent, title): 	# 생성자로 title을 적용한다.
        super(MyFrame, self).__init__(parent, title=title, size=(300, 200))  # 윈도우 너비, 높이 설정

        self.dataList = wx.ListCtrl(self, wx.ID_ANY, wx.DefaultPosition, \
                        wx.DefaultSize, wx.LC_REPORT) 	# ListCtrl을 표 형식으로 설정
        self.dataList.InsertColumn(0, '이름', width=100) 	# 표의 첫 번째 열은 이름으로 지정
        self.dataList.InsertColumn(1, '출생지', width=100) 	# 두 번째 열은 출생지로 지정
        self.dataList.InsertColumn(2, '출생년도', width=100)  # 세 번째 열은 출생년도로 지정

        self.Center()	# 모니터의 중앙에 윈도우 창이 뜨도록 지정

        for f in fdatas:
            index = self.dataList.InsertItem(1000, f[0]) 	# 표의 index행 0열에 이름 저장
            self.dataList.SetItem(index, 1, f[1]) 	# index행 1열에 출생지 저장
            self.dataList.SetItem(index, 2, f[2]) 	# index행 2열에 출생년도 저장

if __name__ == '__main__':
    app = wx.App()	# 프로그램을 구동하고 이벤트를 관리한다.
    MyFrame(None, '윈도우연습').Show()	# 현재가 메인창이므로 생성자에 None, 제목을 전달
    app.MainLoop()	# 프레임을 종료할 때까지 무한루핑(창이 계속 띄워져 있어야 하므로)
