import wx
import wx.xrc

class MyFrame1(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, id=wx.ID_ANY, title=wx.EmptyString,
        pos=wx.DefaultPosition, size=wx.Size(470, 300), style=wx.DEFAULT_FRAME_STYLE | wx.TAB_TRAVERSAL)
        #self.SetSizeHintsSz(wx.DefaultSize, wx.DefaultSize)
        self.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_MENU))
        bSizer1 = wx.BoxSizer(wx.VERTICAL)
        self.m_panel1 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer2 = wx.BoxSizer(wx.HORIZONTAL)
        self.m_staticText1 = wx.StaticText(self.m_panel1, wx.ID_ANY, u"거래처명 : ", wx.DefaultPosition, wx.DefaultSize, 0)
        self.m_staticText1.Wrap(-1)
        bSizer2.Add(self.m_staticText1, 0, wx.ALL, 5)
        self.txtName = wx.TextCtrl(self.m_panel1, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.txtName, 0, wx.ALL, 5)
        self.m_staticText2 = wx.StaticText(self.m_panel1, wx.ID_ANY, u"전화 : ", wx.DefaultPosition, wx.DefaultSize, 0)
        self.m_staticText2.Wrap(-1)
        bSizer2.Add(self.m_staticText2, 0, wx.ALL, 5)
        self.txtTel = wx.TextCtrl(self.m_panel1, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.txtTel, 0, wx.ALL, 5)
        self.btnInsert = wx.Button(self.m_panel1, wx.ID_ANY, u"등록", wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.btnInsert, 0, wx.ALL, 5)
        self.m_panel1.SetSizer(bSizer2)
        self.m_panel1.Layout()
        bSizer2.Fit(self.m_panel1)
        bSizer1.Add(self.m_panel1, 0, wx.ALL, 5)
        self.m_panel2 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer3 = wx.BoxSizer(wx.VERTICAL)
        self.lstView = wx.ListCtrl(self.m_panel2, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.LC_REPORT)
        bSizer3.Add(self.lstView, 1, wx.ALL | wx.EXPAND, 5)
        self.m_panel2.SetSizer(bSizer3)
        self.m_panel2.Layout()
        bSizer3.Fit(self.m_panel2)
        bSizer1.Add(self.m_panel2, 1, wx.EXPAND | wx.ALL, 5)
        self.m_panel3 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer4 = wx.BoxSizer(wx.VERTICAL)
        self.lblCount = wx.StaticText(self.m_panel3, wx.ID_ANY, u"거래처 수 : 0", wx.DefaultPosition, wx.DefaultSize, 0)
        self.lblCount.Wrap(-1)
        bSizer4.Add(self.lblCount, 0, wx.ALL, 5)
        self.m_panel3.SetSizer(bSizer4)
        self.m_panel3.Layout()
        bSizer4.Fit(self.m_panel3)
        bSizer1.Add(self.m_panel3, 1, wx.EXPAND | wx.ALL, 5)
        self.SetSizer(bSizer1)
        self.Layout()
        self.Centre(wx.BOTH)

        # 개발도구에서 작성한 코드
        self.lstView.InsertColumn(0, '거래처', width=250) 	# wxListCtrl에 표제 설정
        self.lstView.InsertColumn(1, '전화번호', width=200)
        # Connect Events
        self.btnInsert.Bind(wx.EVT_BUTTON, self.OnInsert) 	# 등록 버튼은 OnInsert와 바인딩된다.

    # Virtual event handlers, overide them in your derived class
    def OnInsert(self, event):   	# 등록 버튼을 클릭하면 처리될 이벤트 핸들러 메소드
        irum = self.txtName.GetValue()	# 텍스트박스에 입력된 이름 얻기
        junhwa = self.txtTel.GetValue()	# 텍스트박스에 입력된 전화번호 얻기

        index = self.lstView.InsertItem(10000, 0) 	# 최대 행번호를 주고 index로 0을 얻음
        self.lstView.SetItem(index, 0, irum) 	 	# index행 0열에 이름 저장
        self.lstView.SetItem(index, 1, junhwa) 	# index행 0열에 전화번호 저장
        # 전체 건수 표시
        self.lblCount.SetLabelText('거래처 수 : ' + str(self.lstView.GetItemCount()))
        self.txtName.SetValue('') 	# 입력 후 입력 자료 지우기
        self.txtTel.SetValue('')
        self.txtName.SetFocus()	    # 입력 후 거래처 입력박스에 포커스를 준다.

if __name__ == '__main__':
    app = wx.App()
    MyFrame1(None).Show()
    app.MainLoop()
