import MySQLdb

# 연결객체 사용방법1
config = {
    'host':'127.0.0.1', 'user':'root',
    'password':'korea123', 'database':'test', 'port':3306,
    'charset':'UTF8', 'use_unicode':True
}

"""
# 연결객체 사용방법2 - 연결정보를 가진 별도 파일 mysqldb.dat을 호출
import pickle

with open('mysqldb.dat', 'rb') as obj:
    config = pickle.load(obj)
"""

try:
    conn = MySQLdb.connect(**config) #**은 딕셔너리 자료와 매칭됨
    cursor = conn.cursor()

    # ------------------------------------------------------
    # INSERT, UPDATE, DELETE에 대한 연습을 위한 코드를 입력할 영역
    # 실습 코드는 아래 실습 참고 사항에 적어둠
    """
    sql = "insert into sangdata(code,sang,su,dan) values(10,'상품1',2,2000)"
    cursor.execute(sql)  # insert가 실행된다.
    conn.commit()
    """

    """
    sql = "insert into sangdata values(%s, %s, %s, %s)"
    sql_data = ('11', '상품2', 5, 1000)  # 튜플 요솟값을 %s 서식문자와 차례대로 매칭한다.
    cursor.execute(sql, sql_data)
    conn.commit()
    """

    """
    sql = "update sangdata set sang=%s,su=%s,dan=%s where code=%s"
    sql_data = ('파이썬', 7, 7000, '11') 	# 튜플 요소 값을 %s 서식문자와 차례대로 매칭한다.
    cursor.execute(sql, sql_data) 	# update가 실행된다.
    conn.commit()			# 수정 작업을 완료한다.
    """

    """
    code = '10'   
    sql = "delete from sangdata where code=%s"
    cursor.execute(sql, (code, )) 	# %s에 전달되는 값은 튜플이어야 한다.
    conn.commit()
    """

    """
    code = '11'
    sql = "delete from sangdata where code='{0}'".format(code)
    cursor.execute(sql)
    conn.commit()
    """
    # -------------------------------------------------------

    # sangdata 테이블 데이터 읽기
    sql = "select code, sang, su, dan from sangdata"
    cursor.execute(sql)  # select를 실행하고 결괏값을 cursor가 기억

    # select 결과 출력하기 1)
    # cursor가 참조하고 있는 데이터를 한 행(레코드)씩 출력
    for data in cursor.fetchall():
        # print(data)
        print('%s %s %s %s'%data) # data는 code, sang, su, dan 기억

    # select 결과 출력하기 2)
    cursor.execute(sql)
    # cursor에 기억된 레코드의 컬럼 데이터가 변수와 일대일 매칭
    for (code, sang, su, dan) in cursor:
        print(code, sang, su, dan)
except Exception as err:
    print('오류:', err)
    conn.rollback()   # select 문만 사용할 경우에는 적지 않는다.
finally:
    cursor.close()
    conn.close()
