import wx
import wx.xrc
import MySQLdb
import pickle

with open('mysqldb.dat', 'rb') as obj:
    config = pickle.load(obj)

class MyFrame(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, id=wx.ID_ANY, title=u"CRUD test", pos=wx.DefaultPosition,
                          size=wx.Size(322, 384), style=wx.DEFAULT_FRAME_STYLE | wx.TAB_TRAVERSAL)

        # self.SetSizeHintsSz( wx.DefaultSize, wx.DefaultSize )
        self.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_MENU))

        bSizer1 = wx.BoxSizer(wx.VERTICAL)

        self.m_panel1 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer2 = wx.BoxSizer(wx.HORIZONTAL)

        self.m_staticText1 = wx.StaticText(self.m_panel1, wx.ID_ANY, u"번호 : ", wx.DefaultPosition, wx.DefaultSize, 0)
        self.m_staticText1.Wrap(-1)
        bSizer2.Add(self.m_staticText1, 0, wx.ALL, 5)

        self.txtNo = wx.TextCtrl(self.m_panel1, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.txtNo, 0, wx.ALL, 5)

        self.btnInsert = wx.Button(self.m_panel1, wx.ID_ANY, u"등록", wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.btnInsert, 0, wx.ALL, 5)

        self.m_panel1.SetSizer(bSizer2)
        self.m_panel1.Layout()
        bSizer2.Fit(self.m_panel1)
        bSizer1.Add(self.m_panel1, 0, wx.EXPAND | wx.ALL, 5)

        self.m_panel2 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer3 = wx.BoxSizer(wx.HORIZONTAL)

        self.m_staticText2 = wx.StaticText(self.m_panel2, wx.ID_ANY, u"이름 : ", wx.DefaultPosition, wx.DefaultSize, 0)
        self.m_staticText2.Wrap(-1)
        bSizer3.Add(self.m_staticText2, 0, wx.ALL, 5)

        self.txtName = wx.TextCtrl(self.m_panel2, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer3.Add(self.txtName, 0, wx.ALL, 5)

        self.btnUpdate = wx.Button(self.m_panel2, wx.ID_ANY, u"수정", wx.DefaultPosition, wx.Size(50, -1), 0)
        bSizer3.Add(self.btnUpdate, 0, wx.ALL, 5)

        self.btnConfirm = wx.Button(self.m_panel2, wx.ID_ANY, u"확인", wx.DefaultPosition, wx.Size(50, -1), 0)
        bSizer3.Add(self.btnConfirm, 0, wx.ALL, 5)

        self.m_panel2.SetSizer(bSizer3)
        self.m_panel2.Layout()
        bSizer3.Fit(self.m_panel2)
        bSizer1.Add(self.m_panel2, 0, wx.EXPAND | wx.ALL, 5)

        self.m_panel3 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer4 = wx.BoxSizer(wx.HORIZONTAL)

        self.m_staticText3 = wx.StaticText(self.m_panel3, wx.ID_ANY, u"전화 : ", wx.DefaultPosition, wx.DefaultSize, 0)
        self.m_staticText3.Wrap(-1)
        bSizer4.Add(self.m_staticText3, 0, wx.ALL, 5)

        self.txtTel = wx.TextCtrl(self.m_panel3, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer4.Add(self.txtTel, 0, wx.ALL, 5)

        self.btnDelete = wx.Button(self.m_panel3, wx.ID_ANY, u"삭제", wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer4.Add(self.btnDelete, 0, wx.ALL, 5)

        self.m_panel3.SetSizer(bSizer4)
        self.m_panel3.Layout()
        bSizer4.Fit(self.m_panel3)
        bSizer1.Add(self.m_panel3, 0, wx.EXPAND | wx.ALL, 5)

        self.m_panel4 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer5 = wx.BoxSizer(wx.VERTICAL)

        self.lstMember = wx.ListCtrl(self.m_panel4, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.LC_REPORT)
        bSizer5.Add(self.lstMember, 1, wx.ALL | wx.EXPAND, 5)

        self.m_panel4.SetSizer(bSizer5)
        self.m_panel4.Layout()
        bSizer5.Fit(self.m_panel4)
        bSizer1.Add(self.m_panel4, 1, wx.EXPAND | wx.ALL, 5)

        self.m_panel5 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer6 = wx.BoxSizer(wx.HORIZONTAL)

        self.m_staticText4 = wx.StaticText(self.m_panel5, wx.ID_ANY, u"인원수 : ", wx.DefaultPosition, wx.DefaultSize, 0)
        self.m_staticText4.Wrap(-1)
        bSizer6.Add(self.m_staticText4, 0, wx.ALL, 5)

        self.lblCnt = wx.StaticText(self.m_panel5, wx.ID_ANY, u"0", wx.DefaultPosition, wx.DefaultSize, 0)
        self.lblCnt.Wrap(-1)
        bSizer6.Add(self.lblCnt, 0, wx.ALL, 5)

        self.m_panel5.SetSizer(bSizer6)
        self.m_panel5.Layout()
        bSizer6.Fit(self.m_panel5)
        bSizer1.Add(self.m_panel5, 1, wx.EXPAND | wx.ALL, 5)

        self.SetSizer(bSizer1)
        self.Layout()

        self.Centre(wx.BOTH)

        # lstMember에 제목주기
        self.lstMember.InsertColumn(0, '번호', width=50)
        self.lstMember.InsertColumn(1, '이름', width=100)
        self.lstMember.InsertColumn(2, '전화', width=150)

        # Connect Events
        self.btnInsert.id = 1
        self.btnUpdate.id = 2  # 실행 중에 id를 변경. 이유는 수정:2, 취소:5  두 가지 작업을 함
        self.btnConfirm.id = 3  # 실제로 수정 처리
        self.btnDelete.id = 4

        self.btnInsert.Bind(wx.EVT_BUTTON, self.btnProcess)
        self.btnUpdate.Bind(wx.EVT_BUTTON, self.btnProcess)
        self.btnConfirm.Bind(wx.EVT_BUTTON, self.btnProcess)
        self.btnDelete.Bind(wx.EVT_BUTTON, self.btnProcess)

        self.btnConfirm.Enable(enable=False)  # 수정 확인버튼은 비황성화 상태에서 출발
        self.showData()

    def __del__(self):
        pass

    # Virtual event handlers, overide them in your derived class
    def btnProcess(self, event):
        id = event.GetEventObject().id

        if id == 1:
            self.memInsert()  # 등록처리 메소드 호출
        elif id == 2:
            self.memUpdateReady()  # 수정준비 메소드 호출
        elif id == 3:
            self.memUpdateProcess()  # 수정처리 메소드 호출
        elif id == 4:
            self.memDelete()  # 삭제처리 메소드 호출
        elif id == 5:
            self.memUpdateCancel()  # 수정취소 메소드 호출

    def showData(self):
        try:
            conn = MySQLdb.connect(**config)
            cursor = conn.cursor()

            sql = "select * from pymem"
            cursor.execute(sql)

            self.lstMember.DeleteAllItems()  # lstMember 초기화
            count = 0
            for data in cursor:
                i = self.lstMember.InsertItem(10000, 0)  # 동적인 번호 부여 (65535 까지 가능)
                self.lstMember.SetItem(i, 0, str(data[0]))  # 번호
                self.lstMember.SetItem(i, 1, data[1])  # 이름
                self.lstMember.SetItem(i, 2, data[2])  # 전화
                count += 1   # 인원수 누적

            self.lblCnt.SetLabel(str(count))  # 인원수 출력
        except Exception as e:
            wx.MessageBox('읽기 오류', '에러 : ' + str(e), wx.OK)
        finally:
            cursor.close()   # 작업이 끝난 객체 해제
            conn.close()

    def memInsert(self):  # 회원추가
        no = self.txtNo.GetValue()
        name = self.txtName.GetValue()
        tel = self.txtTel.GetValue()

        if no == '' or name == '' or tel == '':
            wx.MessageBox('자료를 입력하시오', '알림', wx.OK)
            return

        try:
            conn = MySQLdb.connect(**config)
            cursor = conn.cursor()

            # 새로운 번호의 등록이 가능한지 확인 작업
            data = self.selectData(no)

            if data != None:
                wx.MessageBox('이미 등록된 번호입니다', '알림', wx.OK)
                self.txtNo.SetFocus()
                return

            # 등록이 가능한 상태라면 등록작업 계속 진행
            sql = "insert into pymem values(%s,%s,%s)"
            cursor.execute(sql, (no, name, tel))
            conn.commit()  # 등록이 완료

            self.showData()  # 자료 추가 후 전체자료 출력

            self.txtNo.SetValue('')  # 화면에 입력한 자료 초기화
            self.txtName.SetValue('')
            self.txtTel.SetValue('')
        except Exception as e:
            wx.MessageBox('추가 오류 :' + str(e), '에러', wx.OK)
            conn.rollback()  # DB에 입력작업 취소
        finally:
            cursor.close()
            conn.close()

    def memUpdateReady(self):  # 회원수정 준비
        textDlg = wx.TextEntryDialog(None, '수정할 번호를 입력하시오', '알림')
        if textDlg.ShowModal() == wx.ID_OK:
            if textDlg.GetValue() == '':
                return

            upno = textDlg.GetValue()
            data = self.selectData(upno)
            if data == None:
                wx.MessageBox(upno + "번은 등록된 자료가 아닙니다", "알림", wx.OK)
                return

            # 수정 준비작업 계속
            self.txtNo.SetValue(str(data[0]))  # 수정할 자료 화면에 표시
            self.txtName.SetValue(data[1])
            self.txtTel.SetValue(data[2])

            self.txtNo.SetEditable(False)  # 번호는 Primary key이므로 수정에서 제외해야 함
            self.btnUpdate.SetLabel('취소')  # 수정에서 취소로 변경할 수 있도록 함
            self.btnUpdate.id = 5  # id는 수정에서 취소로 처리되도록 함
            self.btnConfirm.Enable(enable=True)  # 확인 버튼 활성화
        else:
            return

        textDlg.Destroy()  # TextEntryDialog 닫기 마무리 처리함

    def memUpdateProcess(self):  # 회원수정 처리
        no = self.txtNo.GetValue()
        name = self.txtName.GetValue()
        tel = self.txtTel.GetValue()

        if name == '' or tel == '':
            wx.MessageBox('수정 자료를 입력하시오', '알림', wx.OK)
            return

        try:
            conn = MySQLdb.connect(**config)
            cursor = conn.cursor()

            sql = "update pymem set irum=%s,junhwa=%s where bun=%s"
            cursor.execute(sql, (name, tel, no))
            conn.commit()

            self.showData()  # 자료 수정 후 전체자료 출력
            self.memUpdateCancel()  # 수정 후 화면 초기화
        except Exception as e:
            wx.MessageBox('수정 에러 : ' + str(e), '알림', wx.OK)
            conn.rollback()
        finally:
            cursor.close()
            conn.close()

    def memUpdateCancel(self):  # 회원수정 준비를 취소
        self.txtNo.SetValue('')
        self.txtName.SetValue('')
        self.txtTel.SetValue('')

        self.txtNo.SetEditable(True)
        self.btnUpdate.SetLabel('수정')
        self.btnUpdate.id = 2
        self.btnConfirm.Enable(enable=False)

    def memDelete(self):  # 회원삭제
        textDlg = wx.TextEntryDialog(None, '삭제할 번호를 입력하시오', '알림')
        if textDlg.ShowModal() == wx.ID_OK:
            if textDlg.GetValue() == '':
                return

            delno = textDlg.GetValue()
            data = self.selectData(delno)
            if data == None:
                wx.MessageBox(delno + "번은 등록된 자료가 아닙니다", "알림", wx.OK)
                return

            # 삭제 작업 계속 진행
            try:
                conn = MySQLdb.connect(**config)
                cursor = conn.cursor()
                sql = "delete from pymem where bun={}".format(delno)
                cursor.execute(sql)
                conn.commit()

                self.showData()  # 자료 삭제 후 전체자료 출력
            except Exception as e:
                wx.MessageBox("삭제 에러 : " + str(e), "에러", wx.OK)
                conn.rollback()
            finally:
                cursor.close()
                conn.close()

        else:
            return

        textDlg.Destroy()  # TextEntryDialog 닫기 마무리 처리함

    def selectData(self, no):  # 한 개의 레코드 읽기 작업(추가, 수정, 삭제에서 사용)
        try:
            conn = MySQLdb.connect(**config)
            cursor = conn.cursor()

            sql = "select * from pymem where bun={0}".format(no)
            cursor.execute(sql)
            data = cursor.fetchone()
            # print(data)  # 있으면 tuple로 보이고, 없으면 None

            return data
        except Exception as e:
            wx.MessageBox('행 읽기 오류 :' + str(e), '에러', wx.OK)
        finally:
            cursor.close()
            conn.close()


if __name__ == '__main__':
    app = wx.App()
    MyFrame(None).Show()
    app.MainLoop()