import socket
import threading

ss = socket.socket(socket.AF_INET, socket.SOCK_STREAM)  # 서버 소켓 객체를 생성한다.
ss.bind(('127.0.0.1', 5000))      # 접속 서버의 ip 주소와 포트 번호를 설정한다.
ss.listen(5)                      # 클라이언트의 요청을 기다린다.
print('채팅 서버 서비스 시작...')
users = []                        # 모든 클라이언트와의 연결 객체를 저장하는 리스트 변수

def ChatUser(conn):               # 각 클라이언트와 연결 및 데이터 송수신 처리 함수
    name = conn.recv(1024)             # 클라이언트로부터 채팅명을 수신한다.
    data = '^^ ' + name.decode('UTF-8') + '님 입장 ^^'     # 입장 알림 송신 메시지
    print(data)

    try:
        for p in users:
            p.send(data.encode('UTF-8'))  # 접속 중인 모든 클라이언트에게 채팅명을 송신한다.

        while True:
            msg = conn.recv(1024)     # 접속 중인 클라이언트로부터 계속적인 메시지 수신
            data = name.decode('UTF-8') + '님 메시지:' + msg.decode('UTF-8')
            for p in users:
                p.send(data.encode('UTF-8'))  # 모든 클라이언트에게 지속적으로 메시지 송신
    except:
        users.remove(conn)    # 채팅을 끝낸 클라이언트 연결 객체를 users에서 삭제
        data = '~~ ' + name.decode('UTF-8') + '님 퇴장 ~~'
        print(data)

        if users:
            for p in users:
                p.send(data.encode('UTF-8'))  # 모든 클라이언트에게 특정 접속자의 퇴장을 알린다.
        else:
            print('exit')

while True:
    conn, addr = ss.accept()   # 클라이언트와의 연결 대기 상태가 된다.
    users.append(conn)         # 임의의 클라이언트가 접속하면 연결 객체를 users에 넣어 둔다.

    th = threading.Thread(target=ChatUser, args=(conn,))  # 스레드 객체를 생성한다.
    th.start()                 # ChatUser 함수를 호출한다.
