import threading, time

def func(id):            # 스레드 처리 대상 함수. 1~5까지 숫자 출력 
    for i in range(1, 6):
        print('id={} --> {}'.format(id, i))  # 1~5까지 숫자 출력
        time.sleep(0.5)  # 처리 과정을 천천히 진행하기 위해 0.5초 동안 비활성화

# [처리 1] thread를 사용하지 않음. func 함수를 순차적으로 수행
func(1)     # 인수1을 담아 func 함수를 호출
func(2)     # func(1) 처리가 끝나면 바로 이어서 수행됨

# [처리 2] thread 객체를 생성하여 사용. threading.Thread(target=수행함수명)
print('스레드 사용-----------------')
th1 = threading.Thread(target=func, args=('일'))   # 스레드 처리용 함수를 func라고 지정
th2 = threading.Thread(target=func, args=('이'))

th1.start()         # 스레드 처리를 시작한다. func가 호출된다.
th2.start()         # func를 두 번째 스레드로 호출함

th1.join()          # 사용자 정의 스레드가 종료될 때까지 메인 스레드의 대기를 요청
th2.join()          # join()을 주석 처리하면 메인 스레드가 먼저 처리되기도 한다.

print('프로그램 종료')
