from multiprocessing import Pool
import time
import os

def pool_func(arg):
    print('값', arg, '에 대한 pid : ', os.getpid())  # 현재 실행되는 process의 id를 출력
    time.sleep(1)    # 너무 빠른 처리가 되지 않도록 편의상 약간의 지연 시간을 준다.
    return arg + 10  # 매개변수 값에 10을 더해 반환한다

# pool_func(3) # 결괏값 3에 대한 pid : 57. 실행 후 아래 처리에 방해되므로 주석처리 하자

print()
if __name__ == '__main__':
    startTime = int(time.time())  # 처리 수행시간 체크용

    # [방법 1] Pool 객체를 사용하지 않은 일반적인 방법으로 함수를 호출하기
    for i in range(10):
        print(pool_func(i))  # 총 작업 시간: 10 초

    endTime = int(time.time())
    print('총 작업 시간 :', (endTime - startTime))

    print()

    # [방법 2] 멀티 태스킹이 가능한 Pool 객체로 함수를 호출하기
    startTime = int(time.time())
    po = Pool(processes=3)  # process 개수를 인자로 주고 함수를 호출
    print(po.map(pool_func, range(10)))  # 함수와 인자값을 매칭하면서 처리한다. 10회 반복한다.

    endTime = int(time.time())
    print('총 작업 시간 :', (endTime - startTime))
