from multiprocessing import Pool
import urllib.request		    # 특정 사이트의 웹 문서를 읽기 위한 모듈
from bs4 import BeautifulSoup	# 읽혀진 웹 문서를 처리하기 위한 모듈
import time

def getLinks_func():	 # 특정 사이트와 연결을 위해 링크된 a tag의 url을 가져오기 위한 함수
    data = urllib.request.urlopen('https://beomi.github.io/beomi.github.io_old/')
    bsObj = BeautifulSoup(data, 'html.parser')
    # print(bsObj)
    my_titles = bsObj.select('h3 > a')
    data = []
    for title in my_titles:
        data.append(title.get('href'))
    return data

def getContent_func(link): 	# getLinks_func 함수에서 전달받은 url로 접속해 제목 읽기 함수
    imsi_link = 'https://beomi.github.io' + link
    data = urllib.request.urlopen(imsi_link)
    bsObj2 = BeautifulSoup(data, 'html.parser')
    #  가져온 데이터로 처리 작업(그러나 여기에서는 그저 처리 소요 시간이 궁금할 따름이다)
    print(bsObj2.select('h1')[0].text) 	# 첫 번째 h1 tag의 텍스트 하나만 출력해 본다.

if __name__ == '__main__':
    print('처리1 : 멀티 프로세싱을 사용하지 않은 경우 ---')
    start_time = time.time()	# 처리 시작 시간으로 사용하기 위해 현재 시간 기억
    # print(getLinks_func)

    for link in getLinks_func():
        getContent_func(link)

    print('처리1 : %s 초---' % (time.time() - start_time)) 	# 처리 결과 시간은 동적이다

    print('\n처리2 : Pool 클래스로 멀티 프로세싱을 사용한 경우 ---')
    start_time2 = time.time()
    pool = Pool(processes=3) 	# 세 개의 process 사용
    pool.map(getContent_func, getLinks_func())	# 함수와 인자값을 매칭하면서 처리

    print('처리2 : %s 초---' % (time.time() - start_time2))
