import re

ss = '1234 abc가나다ABC_555_6'
m1 = re.match(r'1234', ss)
print(m1.group())

print(re.match(r'[0-9]?', ss).group())
print(re.match(r'[0-9]+', ss).group())
print(re.match(r'[0-9]*', ss).group())
print(re.match(r'[0-9]?', ss).group())	# 결과의 부분집합을 반환한다.

m = re.match(r'[0-9]+(\s\D\w+)(\d{2})', ss) # ( )로 그룹화한다.
print(m.group())		# match의 결과를 출력한다.
print(m.group(1)) 	    # 첫 번째 그룹 참조한다.
print(m.group(2)) 	    # 두 번째 그룹 참조한다.
print(m.groups())		# 그룹 전체가 튜플로 출력한다.

print(re.escape('aa 87_호호6&*#bb123'))
# 영문자, 숫자가 아닌 것들을 백슬래시 처리해 반환한다.

# split 함수로 대상 자료 분리하기
# \w : 숫자 또는 문자.  \W : \w 이외의 값이 대상이 된다.
print(re.split('\W+', 'mbc,kbs sbs:ytn'))

# sub 함수로 치환하기
sub = re.sub(r'[0-9]+', '888', '1234 abc가나다ABC_567')
print('sub 결과 : ', sub)

ss2 = '''<a href="abc1.html">abc1</a>
<a href="kbs2.html">abc1</a>'''
# pattern을 만족한 모든 문자열을 참조한다.
result = re.findall(r'href="(.*)"', ss2)
print(result)
