import wx
import wx.xrc

class MyFrame1(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, id=wx.ID_ANY, title=u"BMI", pos=wx.DefaultPosition, size=wx.Size(440, 132),
                          style=wx.DEFAULT_FRAME_STYLE | wx.TAB_TRAVERSAL)

        #self.SetSizeHintsSz(wx.DefaultSize, wx.DefaultSize)
        self.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_MENU))

        bSizer1 = wx.BoxSizer(wx.VERTICAL)

        self.m_panel1 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer2 = wx.BoxSizer(wx.HORIZONTAL)

        self.m_staticText1 = wx.StaticText(self.m_panel1, wx.ID_ANY, u"키 : ", wx.DefaultPosition, wx.DefaultSize, 0)
        self.m_staticText1.Wrap(-1)
        bSizer2.Add(self.m_staticText1, 0, wx.ALL, 5)

        self.txtHeight = wx.TextCtrl(self.m_panel1, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.Size(80, -1), 0)
        bSizer2.Add(self.txtHeight, 0, wx.ALL, 5)

        self.m_staticText2 = wx.StaticText(self.m_panel1, wx.ID_ANY, u"cm   /   몸무게 : ", wx.DefaultPosition,
                                           wx.DefaultSize, 0)
        self.m_staticText2.Wrap(-1)
        bSizer2.Add(self.m_staticText2, 0, wx.ALL, 5)

        self.txtWeight = wx.TextCtrl(self.m_panel1, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.Size(80, -1), 0)
        bSizer2.Add(self.txtWeight, 0, wx.ALL, 5)

        self.m_staticText3 = wx.StaticText(self.m_panel1, wx.ID_ANY, u"kg", wx.DefaultPosition, wx.DefaultSize, 0)
        self.m_staticText3.Wrap(-1)
        bSizer2.Add(self.m_staticText3, 0, wx.ALL, 5)

        self.btnCalc = wx.Button(self.m_panel1, wx.ID_ANY, u"계산", wx.DefaultPosition, wx.Size(70, -1), 0)
        bSizer2.Add(self.btnCalc, 0, wx.ALL, 5)

        self.m_panel1.SetSizer(bSizer2)
        self.m_panel1.Layout()
        bSizer2.Fit(self.m_panel1)
        bSizer1.Add(self.m_panel1, 1, wx.EXPAND | wx.ALL, 5)

        self.m_panel2 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer3 = wx.BoxSizer(wx.HORIZONTAL)

        self.m_staticText6 = wx.StaticText(self.m_panel2, wx.ID_ANY, u"비만도(BMI 지수) 결과 : ", wx.DefaultPosition,
                                           wx.DefaultSize, 0)
        self.m_staticText6.Wrap(-1)
        bSizer3.Add(self.m_staticText6, 0, wx.ALL, 5)

        self.staResult = wx.StaticText(self.m_panel2, wx.ID_ANY, u"0", wx.DefaultPosition, wx.DefaultSize, 0)
        self.staResult.Wrap(-1)
        bSizer3.Add(self.staResult, 0, wx.ALL, 5)

        self.m_panel2.SetSizer(bSizer3)
        self.m_panel2.Layout()
        bSizer3.Fit(self.m_panel2)
        bSizer1.Add(self.m_panel2, 1, wx.EXPAND | wx.ALL, 5)

        self.SetSizer(bSizer1)
        self.Layout()

        self.Centre(wx.BOTH)

        # Connect Events
        self.btnCalc.Bind(wx.EVT_BUTTON, self.CalcProcess)

    def __del__(self):
        pass

    # Virtual event handlers, overide them in your derived class
    def CalcProcess(self, event):
        height = self.txtHeight.GetValue()
        weight = self.txtWeight.GetValue()

        if height == '' or weight == '':
            wx.MessageBox('값을 입력하세요', '오류', wx.OK)
            return

        try:
            height = float(height)  # 문자를 숫자로 형변환
            weight = float(weight)

            imsi = round(weight / (height / 100 * height / 100), 1)
            print(imsi)
            if imsi < 18.5:
                result = '저체중'
            elif 18.5 <= imsi <= 22.9:
                result = '정상'
            elif 23.0 <= imsi <= 24.9:
                result = '과체중'
            else:
                result = '비만'

            self.staResult.SetLabelText(str(imsi) + '으로 ' + result)

        except:
            wx.MessageBox('숫자를 입력하세요', '오류', wx.OK)
            return

if __name__ == '__main__':
    app = wx.App()
    MyFrame1(None).Show()
    app.MainLoop()
