import wx
import wx.xrc
import MySQLdb
import pickle

with open('mysqldb.dat', 'rb') as obj:
    config = pickle.load(obj)

class MyFrameSearch(wx.Frame):
    def __init__(self, parent):
        wx.Frame.__init__(self, parent, id=wx.ID_ANY, title=u"직원찾기", pos=wx.DefaultPosition, size=wx.Size(379, 300),
                          style=wx.DEFAULT_FRAME_STYLE | wx.TAB_TRAVERSAL)

        # self.SetSizeHintsSz( wx.DefaultSize, wx.DefaultSize )
        self.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_MENU))

        bSizer1 = wx.BoxSizer(wx.VERTICAL)

        self.m_panel1 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer2 = wx.BoxSizer(wx.HORIZONTAL)

        self.m_staticText1 = wx.StaticText(self.m_panel1, wx.ID_ANY, u"직급입력 : ", wx.DefaultPosition, wx.DefaultSize, 0)
        self.m_staticText1.Wrap(-1)
        bSizer2.Add(self.m_staticText1, 0, wx.ALL, 5)

        self.txtJik = wx.TextCtrl(self.m_panel1, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.txtJik, 0, wx.ALL, 5)

        self.btnSearch = wx.Button(self.m_panel1, wx.ID_ANY, u"검색", wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.btnSearch, 0, wx.ALL, 5)

        self.m_panel1.SetSizer(bSizer2)
        self.m_panel1.Layout()
        bSizer2.Fit(self.m_panel1)
        bSizer1.Add(self.m_panel1, 0, wx.EXPAND | wx.ALL, 5)

        self.m_panel2 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer3 = wx.BoxSizer(wx.VERTICAL)

        self.lstJikwon = wx.ListCtrl(self.m_panel2, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.LC_REPORT)
        bSizer3.Add(self.lstJikwon, 1, wx.ALL | wx.EXPAND, 5)

        self.m_panel2.SetSizer(bSizer3)
        self.m_panel2.Layout()
        bSizer3.Fit(self.m_panel2)
        bSizer1.Add(self.m_panel2, 1, wx.EXPAND | wx.ALL, 5)

        self.m_panel3 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer4 = wx.BoxSizer(wx.HORIZONTAL)

        self.staCount = wx.StaticText(self.m_panel3, wx.ID_ANY, u"인원수 :", wx.DefaultPosition, wx.Size(150, -1), 0)
        self.staCount.Wrap(-1)
        bSizer4.Add(self.staCount, 0, wx.ALL, 5)

        self.staPayavg = wx.StaticText(self.m_panel3, wx.ID_ANY, u"평균연봉 :", wx.DefaultPosition, wx.DefaultSize, 0)
        self.staPayavg.Wrap(-1)
        bSizer4.Add(self.staPayavg, 0, wx.ALL, 5)

        self.m_panel3.SetSizer(bSizer4)
        self.m_panel3.Layout()
        bSizer4.Fit(self.m_panel3)
        bSizer1.Add(self.m_panel3, 0, wx.EXPAND | wx.ALL, 5)

        self.SetSizer(bSizer1)
        self.Layout()

        self.Centre(wx.BOTH)

        # lstJikwon에 컬럼 추가
        self.lstJikwon.InsertColumn(0, '사번', width=50)
        self.lstJikwon.InsertColumn(1, '직원명', width=120)
        self.lstJikwon.InsertColumn(2, '부서명', width=120)
        self.lstJikwon.InsertColumn(3, '성별', width=50)

        # Connect Events
        self.btnSearch.Bind(wx.EVT_BUTTON, self.SearchProcess)

    # 검색 버튼 누르면 여기로
    def SearchProcess(self, event):
        try:
            conn = MySQLdb.connect(**config)
            cursor = conn.cursor()
            jik = self.txtJik.GetValue()
            if self.txtJik.GetValue() == '':
                sql = '''
                select jikwon_no, jikwon_name, buser_name, jikwon_gen, jikwon_pay
                from jikwon
                left outer join buser on buser_num = buser_no
                '''  # 전체출력
            else:
                sql = '''
                select jikwon_no, jikwon_name, buser_name, jikwon_gen, jikwon_pay
                from jikwon
                left outer join buser on buser_num = buser_no
                where jikwon_jik ='{}'
                '''.format(jik)  # 직급별 출력

            # print(sql)    # 잘돌아가는 확인

            cursor.execute(sql)
            jikwon_datas = cursor.fetchall()

            self.lstJikwon.DeleteAllItems()  # 비워주는것
            self.staCount.SetLabelText('인원수 :')
            self.staPayavg.SetLabelText('연봉평균 :')

            if len(jikwon_datas) == 0:
                wx.MessageBox(jik + ": 없는 직급입니다")
                return

            for j in jikwon_datas:
                i = self.lstJikwon.InsertItem(1000, 0)  # 최대 행수를 정해줌
                self.lstJikwon.SetItem(i, 0, str(j[0]))
                self.lstJikwon.SetItem(i, 1, j[1])
                self.lstJikwon.SetItem(i, 2, j[2])
                self.lstJikwon.SetItem(i, 3, j[3])

            # 평균연봉
            pay = []
            for p in jikwon_datas:
                pay.append(p[4])

            avg = round(sum(pay) / len(pay), 0)

            self.staCount.SetLabelText('인원수 :' + str(len(jikwon_datas)))
            self.staPayavg.SetLabelText('연봉평균 :' + str(avg))
        except Exception as e:
            wx.MessageBox('출력 에러', '알림', e)
        finally:
            cursor.close()
            conn.close()

if __name__ == '__main__':
    app = wx.App()
    MyFrameSearch(None).Show()
    app.MainLoop()
