import wx
import wx.xrc
import MySQLdb
import pickle

with open('mysqldb.dat', 'rb') as obj:
    config = pickle.load(obj)

class MyFrame1(wx.Frame):

    def __init__(self, parent):
        wx.Frame.__init__(self, parent, id=wx.ID_ANY, title=u"직원보기", pos=wx.DefaultPosition, size=wx.Size(352, 300),
                          style=wx.DEFAULT_FRAME_STYLE | wx.TAB_TRAVERSAL)

        # self.SetSizeHintsSz(wx.DefaultSize, wx.DefaultSize)
        self.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_MENU))

        bSizer1 = wx.BoxSizer(wx.VERTICAL)

        self.m_panel1 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer2 = wx.BoxSizer(wx.HORIZONTAL)

        self.rbAll = wx.RadioButton(self.m_panel1, wx.ID_ANY, u"전체", wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.rbAll, 0, wx.ALL, 5)

        self.rbM = wx.RadioButton(self.m_panel1, wx.ID_ANY, u"남", wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.rbM, 0, wx.ALL, 5)

        self.rbF = wx.RadioButton(self.m_panel1, wx.ID_ANY, u"여", wx.DefaultPosition, wx.DefaultSize, 0)
        bSizer2.Add(self.rbF, 0, wx.ALL, 5)

        self.m_panel1.SetSizer(bSizer2)
        self.m_panel1.Layout()
        bSizer2.Fit(self.m_panel1)
        bSizer1.Add(self.m_panel1, 0, wx.EXPAND | wx.ALL, 5)

        self.m_panel2 = wx.Panel(self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL)
        bSizer3 = wx.BoxSizer(wx.VERTICAL)

        self.lstJikwon = wx.ListCtrl(self.m_panel2, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.LC_REPORT)
        bSizer3.Add(self.lstJikwon, 1, wx.ALL | wx.EXPAND, 5)

        self.m_panel2.SetSizer(bSizer3)
        self.m_panel2.Layout()
        bSizer3.Fit(self.m_panel2)
        bSizer1.Add(self.m_panel2, 1, wx.EXPAND | wx.ALL, 5)

        self.SetSizer(bSizer1)
        self.Layout()

        self.Centre(wx.BOTH)

        # Connect Events
        self.rbAll.Bind(wx.EVT_RADIOBUTTON, self.RadioProcess)
        self.rbM.Bind(wx.EVT_RADIOBUTTON, self.RadioProcess)
        self.rbF.Bind(wx.EVT_RADIOBUTTON, self.RadioProcess)

        # lstMember에 제목주기
        self.lstJikwon.InsertColumn(0, '사번', width=50)
        self.lstJikwon.InsertColumn(1, '이름', width=100)
        self.lstJikwon.InsertColumn(2, '직급', width=100)
        self.lstJikwon.InsertColumn(3, '성별', width=50)

    def RadioProcess(self, event):
        try:
            conn = MySQLdb.connect(**config)
            cursor = conn.cursor()

            sql = "select jikwon_no, jikwon_name, jikwon_jik, jikwon_gen from jikwon"
            rdoSel = event.GetEventObject().GetLabel()  # 라디오 선택 결과

            if rdoSel == '남' or rdoSel == '여':
                sql = sql + " where jikwon_gen = '{0}'".format(rdoSel)

            cursor.execute(sql)
            datas = cursor.fetchall()
            self.lstJikwon.DeleteAllItems()  # lstMember 초기화

            for data in cursor:
                i = self.lstJikwon.InsertItem(10000, 0)  # 동적인 번호 부여 (65535 까지 가능)
                self.lstJikwon.SetItem(i, 0, str(data[0]))
                self.lstJikwon.SetItem(i, 1, data[1])
                self.lstJikwon.SetItem(i, 2, data[2])
                self.lstJikwon.SetItem(i, 3, data[3])
        except Exception as err:
            print('처리 오류 : ', err)
        finally:
            cursor.close()
            conn.close()

if __name__ == '__main__':
    app = wx.App()
    MyFrame1(None).Show()
    app.MainLoop()
